/*


    Evolute version 0.7
    Copyright (C) 2010 Antti Vainio

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.


*/

//          menu.cpp

#include <math.h>
#include "global.hpp"

//alkumenu
void menu(float kasautuminen) {
     //Musiikkia!
     if(Mix_PlayingMusic() == 0) soitamusiikki(menumusiikki, -1);
     
     asetakartta("");
     
     bool pois1 = false; //aloita poistuminen
     bool pois2 = false; //ulos loopista!
     short int valinta = 0;
     short int prewvalinta = 0;
     
     while(!pois2) {
                 alkuaika = SDL_GetTicks();
                 
                 //hiiri ja nappulat
                 SDL_GetMouseState(&hiirix,&hiiriy);
                 pelaajaninputit = SDL_GetKeyState(NULL);
                 if(SDL_GetMouseState(NULL, NULL)&SDL_BUTTON(1)) hiiriekanappi = true;
                 else hiiriekanappi = false;
                 
                 //lasketaan kasautuminen
                 if(!pois1) kasautuminen++;
                 else kasautuminen-= 3;
                 if(pois1 && kasautuminen < 3) pois2 = true;
                 if(kasautuminen < 120) SDL_SetAlpha(valkoinenfade, SDL_SRCALPHA, int(round(255 - kasautuminen * 2.125)));
                 else SDL_SetAlpha(valkoinenfade, SDL_SRCALPHA, 0);
                 
                 //testataan onko hiiri nappien päällä
                 if(kasautuminen > 135 && hiirix > 250 && hiirix < 550) {
                           if(hiiriy > 145 && hiiriy < 205) valinta = 1;
                           //else if(hiiriy > 220 && hiiriy < 280) valinta = 2;
                           else if(hiiriy > 245 && hiiriy < 305) valinta = 3;
                           else if(hiiriy > 345 && hiiriy < 405) valinta = 4;
                           else if(hiiriy > 445 && hiiriy < 505) valinta = 5;
                           else valinta = 0;
                 }
                 else valinta = 0;
                 
                 //testataan irroitettiinko hiiri napin päällä
                 if(kasautuminen > 135 && valinta != 0 && hiiriprewekanappi && !hiiriekanappi) {
                                 if(valinta == 5) {
                                            kokonaanpois = true; //poistutaan ohjelmasta
                                            menuvalinta = -1;
                                            pois1 = true;
                                            kasautuminen = 120;
                                            Mix_FadeOutMusic(1000);
                                 }
                                 else {
                                            pois2 = true;
                                            menuvalinta = valinta;
                                 }
                                 soitaaani(nappi2); //ääni
                 }
                 
                 //nappiäänet
                 if(hiiriekanappi && !hiiriprewekanappi && valinta != 0) soitaaani(nappi1);
                 else if(valinta != prewvalinta && valinta != 0) {
                            if(hiiriekanappi) soitaaani(nappi1);
                            else soitaaani(nappion);
                 }
                 
                 if(kasautuminen > 135) {
                                 if(pelaajaninputit[SDLK_ESCAPE]) { //ESC-nappi
                                                   soitaaani(nappi2); //ääni
                                                   kokonaanpois = true;
                                                   menuvalinta = -1;
                                                   pois1 = true;
                                                   kasautuminen = 120;
                                                   Mix_FadeOutMusic(1000);
                                 }
                                 else if(pelaajaninputit[SDLK_RETURN]) { //ENTER-nappi
                                                   soitaaani(nappi2); //ääni
                                                   pois2 = true;
                                                   menuvalinta = 1; //new game
                                 }
                 }
                 
                      //Piirretään kaikki
                 piirrakuva2(menutausta, 0, 0);
                 piirrakuva(otsikko, 400, 50);
                 //napit
                 if(kasautuminen < 100 && !pois1) piirrakuva(menunappinew1, 0 - 167 + int(round(0.5 * (0 - 0.3) * pow(kasautuminen - 20, 2) + 19.0875 * (kasautuminen - 20))), 175);
                 else if(valinta == 1 && hiiriprewekanappi) piirrakuva(menunappinew2[2], 400, 175);
                 else if(valinta == 1) piirrakuva(menunappinew2[1], 400, 175);
                 else piirrakuva(menunappinew1, 400, 175);
                 /*if(kasautuminen < 110 && !pois1) piirrakuva(menunappiscores1, 0 - 167 + int(round(0.5 * (0 - 0.3) * pow(kasautuminen - 30, 2) + 19.0875 * (kasautuminen - 30))), 250);
                 else if(valinta == 2 && hiiriprewekanappi) piirrakuva(menunappiscores2[2], 400, 250);
                 else if(valinta == 2) piirrakuva(menunappiscores2[1], 400, 250);
                 else piirrakuva(menunappiscores1, 400, 250);*/
                 if(kasautuminen < 110 && !pois1) piirrakuva(menunappisettings1, 0 - 167 + int(round(0.5 * (0 - 0.3) * pow(kasautuminen - 30, 2) + 19.0875 * (kasautuminen - 30))), 275);
                 else if(valinta == 3 && hiiriprewekanappi) piirrakuva(menunappisettings2[2], 400, 275);
                 else if(valinta == 3) piirrakuva(menunappisettings2[1], 400, 275);
                 else piirrakuva(menunappisettings1, 400, 275);
                 if(kasautuminen < 120 && !pois1) piirrakuva(menunappicredits1, 0 - 167 + int(round(0.5 * (0 - 0.3) * pow(kasautuminen - 40, 2) + 19.0875 * (kasautuminen - 40))), 375);
                 else if(valinta == 4 && hiiriprewekanappi) piirrakuva(menunappicredits2[2], 400, 375);
                 else if(valinta == 4) piirrakuva(menunappicredits2[1], 400, 375);
                 else piirrakuva(menunappicredits1, 400, 375);
                 if(kasautuminen < 130 && !pois1) piirrakuva(menunappiexit1, 0 - 167 + int(round(0.5 * (0 - 0.3) * pow(kasautuminen - 50, 2) + 19.0875 * (kasautuminen - 50))), 475);
                 else if(pois1) piirrakuva(menunappiexit2[0], 400, 475);
                 else if(valinta == 5 && hiiriprewekanappi) piirrakuva(menunappiexit2[2], 400, 475);
                 else if(valinta == 5) piirrakuva(menunappiexit2[1], 400, 475);
                 else piirrakuva(menunappiexit1, 400, 475);
                 //loput
                 if(showfpseverywhere == 2) piirraexpluku(fps, 7);
                 piirrakuva2(menutahtain, hiirix - 1, hiiriy - 1);
                 if(kasautuminen < 120) piirrakuva2(valkoinenfade, 0, 0); //fade kaiken päälle
                 
                 SDL_Flip(ruutu);
                 
                 //Lopussa tehtävät asiat
                 if(hiiriekanappi) hiiriprewekanappi = true;
                 else hiiriprewekanappi = false;
                 prewvalinta = valinta;
                 
                      if(hoidatapahtumat() && !pois1) pois2 = true;
                      laskefps();
                      
    //tähän loppuu menun looppi
    }
}
